package com.logicbig.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import java.util.Arrays;
import java.util.List;

@Component
public class ExampleClient {

    @Autowired
    private EmployeeRepository repo;

    public void run() {
        List<Employee> employees = createEmployees();
        repo.saveAll(employees);

        System.out.println(" -- finding all employees --");
        Iterable<Employee> all = repo.findAll();
        all.forEach(System.out::println);

        System.out.println(" -- finding max/min of average salaries in Admin and IT depts  --");
        Object[][] maxAvgSalaries = repo.findMaxMinAvgSalariesOfDept(Arrays.asList("Admin", "IT"));
        for (Object[] maxAvgSalary : maxAvgSalaries) {
            System.out.println("max avg salary: " + maxAvgSalary[0]);
            System.out.println("min avg salary: " + maxAvgSalary[0]);
        }
    }

    private List<Employee> createEmployees() {
        return Arrays.asList(
                Employee.create("Diana", "Admin", 2000),
                Employee.create("Mike", "Sale", 1000),
                Employee.create("Rose", "IT", 4000),
                Employee.create("Sara", "Admin", 3500),
                Employee.create("Randy", "Sale", 3000),
                Employee.create("Charlie", "IT", 2500)
        );
    }
}